<?php

/**
 * Created by PhpStorm.
 * User: michal.mleczko
 * Date: 2016-07-03
 * Time: 23:58
 */
class WPCookiesBarSettingsPage {
	/**
	 * Holds the values to be used in the fields callbacks
	 */
	private $options;

	/**
	 * Start up
	 */
	public function __construct() {
		add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'page_init' ) );
	}

	/**
	 * Add options page
	 */
	public function add_plugin_page() {
		// This page will be under "Settings"
		add_options_page(
			'WP Cookies Bar - Ustawienia',
			'WP Cookies Bar',
			'manage_options',
			'wp-cookies-bar',
			array( $this, 'create_admin_page' )
		);
	}

	/**
	 * Options page callback
	 */
	public function create_admin_page() {
		// Set class property
		$this->options = get_option( 'wp_cookies_bar_path' );
		?>
		<div class="wrap">
			<h2>WP Cookies Bar</h2>
			<form method="post" action="options.php">
				<?php
				// This prints out all hidden setting fields
				settings_fields( 'wp_cookies_option_group' );
				do_settings_sections( 'my-setting-admin' );
				submit_button();
				?>
			</form>
		</div>
		<?php
	}

	/**
	 * Register and add settings
	 */
	public function page_init() {
		register_setting(
			'wp_cookies_option_group', // Option group
			'wp_cookies_bar_path', // Option name
			array( $this, 'sanitize' ) // Sanitize
		);

		add_settings_section(
			'wp_cookies_bar_path_section_id', // ID
			'Ustawienia', // Title
			array( $this, 'print_section_info' ), // Callback
			'my-setting-admin' // Page
		);

		add_settings_field(
			'wp_cookies_bar_path', // ID
			'Wybierz stronę', // Title
			array( $this, 'id_number_callback' ), // Callback
			'my-setting-admin',
			'wp_cookies_bar_path_section_id'
		);
	}

	/**
	 * Sanitize each setting field as needed
	 *
	 * @param array $input Contains all settings fields as array keys
	 *
	 * @return array
	 */
	public function sanitize( $input ) {
		return $input;
		$new_input = array();
		if ( isset( $input['wp_cookies_bar_path'] ) ) {
			$new_input['wp_cookies_bar_path'] = (int) $input['wp_cookies_bar_path'];
		}

		return $new_input;
	}

	/**
	 * Print the Section text
	 */
	public function print_section_info() {
		print 'Wybierz podstronę, do której kierować ma odnośnik na informacji o ciasteczkach. W przypadku niewybrania żadnej - odnośnik się nie pojawi:';
	}

	/**
	 * Get the settings option array and print one of its values
	 */
	public function id_number_callback() {
		$args = array(
			'depth'                 => 0,
			'child_of'              => 0,
			'selected'              => $this->options,
			'echo'                  => 1,
			'name'                  => 'wp_cookies_bar_path',
			'id'                    => null,
			'class'                 => null,
			'show_option_none'      => 'Brak odnośnika',
			'show_option_no_change' => null,
			'option_none_value'     => null,
		);
		wp_dropdown_pages( $args );
	}
}